// Written by Dr. YIP Chi Lap [Beta]
//   for Workshop on "Scene Analysis Using Webcam",
//   Sea Level Measurement Device Design Competition,
//   Faculty of Engineering, The University of Hong Kong, 2014.
//   http://www.cs.hku.hk/~sealevel/

PImage img;


void setup() {
  // load the image
  img = loadImage("IMG_5744.jpg");

  // make window same size as that of image
  size(img.width, img.height);

  // allow us to access the image pixels
  loadPixels();
}


void draw() {
  // use image as background
  background(img);
}


/*
  Whenever the mouse is moved,
    the sum of brightness values of all pixels
    on the vertical line the mouse is in is printed.
 */
void mouseMoved() {
  // The sum is initialized to zero for accumulation of brightness values
  int sum = 0;
  // Since we are examining all pixels in the image,
  //   so we loop from 0 to the full height of the image.
  for (int y=0; y<img.height; ++y) {
    // We get the colour of the pixel in the usual way.
    // Note that the y-coordinate is the value of loop variable y,
    //  and the x-coordinate is that of the current mouse position.
    color p = img.pixels[img.width*y + mouseX];
    // The += operator means add to.
    // The brightness value on the right hand side
    //   is added to the sum on the left hand side.
    sum += brightness(p);
  }
  // The sum is printed.
  println(sum);
}
